commit 9abee17017a485455a2e5599e5332e5ff4e96be8
Author: jklowden <jklowden>
Date:   Sun Feb 1 22:29:38 2009 +0000

    read unit test SQL from external file.

diff --git a/ChangeLog b/ChangeLog
index 527f788..1e7ee47 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,34 @@
+Sun Feb  1 17:15:49 EST 2009	JK Lowden <jklowden@freetds.org>
+	* src/dblib/unittests/common.h src/dblib/unittests/common.c
+	* src/dblib/unittests/bcp.c src/dblib/unittests/dbmorecmds.c
+	* src/dblib/unittests/done_handling.c src/dblib/unittests/rpc.c
+	* src/dblib/unittests/t0001.c src/dblib/unittests/t0002.c
+	* src/dblib/unittests/t0003.c src/dblib/unittests/t0004.c
+	* src/dblib/unittests/t0005.c src/dblib/unittests/t0006.c
+	* src/dblib/unittests/t0007.c src/dblib/unittests/t0008.c
+	* src/dblib/unittests/t0009.c src/dblib/unittests/t0011.c
+	* src/dblib/unittests/t0012.c src/dblib/unittests/t0013.c
+	* src/dblib/unittests/t0014.c src/dblib/unittests/t0015.c
+	* src/dblib/unittests/t0016.c src/dblib/unittests/t0017.c
+	* src/dblib/unittests/t0018.c src/dblib/unittests/t0020.c
+	* src/dblib/unittests/t0021.c src/dblib/unittests/t0022.c
+	* src/dblib/unittests/t0023.c
+	* src/dblib/unittests/text_buffer.c src/dblib/unittests/timeout.c
+	* src/dblib/unittests/bcp.sql src/dblib/unittests/dbmorecmds.sql
+	* src/dblib/unittests/done_handling.sql src/dblib/unittests/rpc.sql
+	* src/dblib/unittests/t0001.sql src/dblib/unittests/t0002.sql
+	* src/dblib/unittests/t0003.sql src/dblib/unittests/t0004.sql
+	* src/dblib/unittests/t0005.sql src/dblib/unittests/t0006.sql
+	* src/dblib/unittests/t0007.sql src/dblib/unittests/t0009.sql
+	* src/dblib/unittests/t0011.sql src/dblib/unittests/t0012.sql
+	* src/dblib/unittests/t0013.sql src/dblib/unittests/t0014.sql
+	* src/dblib/unittests/t0015.sql src/dblib/unittests/t0016.sql
+	* src/dblib/unittests/t0017.sql src/dblib/unittests/t0018.sql
+	* src/dblib/unittests/t0020.sql src/dblib/unittests/t0022.sql
+	* src/dblib/unittests/t0023.sql
+	* src/dblib/unittests/text_buffer.sql src/dblib/unittests/timeout.sql
+	- read unit test SQL from external file. 
+
 Sat Jan 31 13:15:26 EST 2009	JK Lowden <jklowden@freetds.org>
 	* doc/api_status.txt
 	* include/sybdb.h
@@ -1237,4 +1268,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2717 2009/01/31 19:13:19 jklowden Exp $
+$Id: ChangeLog,v 1.2718 2009/02/01 22:29:38 jklowden Exp $
diff --git a/src/dblib/unittests/bcp.c b/src/dblib/unittests/bcp.c
index 511d42d..d777aa3 100644
--- a/src/dblib/unittests/bcp.c
+++ b/src/dblib/unittests/bcp.c
@@ -13,7 +13,7 @@
 
 #include "bcp.h"
 
-static char software_version[] = "$Id: bcp.c,v 1.16 2008/12/19 10:38:56 freddy77 Exp $";
+static char software_version[] = "$Id: bcp.c,v 1.17 2009/02/01 22:29:39 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static char cmd[512];
@@ -46,9 +46,7 @@ init(DBPROCESS * dbproc, const char *name)
 	RETCODE rc;
 
 	fprintf(stdout, "Dropping %s.%s..%s\n", SERVER, DATABASE, name);
-	add_bread_crumb();
-	sprintf(cmd, "if exists (select 1 from sysobjects where type = 'U' and name = '%s') drop table %s", name, name);
-	dbcmd(dbproc, cmd);
+	sql_cmd(dbproc, INPUT);
 	add_bread_crumb();
 	dbsqlexec(dbproc);
 	add_bread_crumb();
@@ -60,14 +58,9 @@ init(DBPROCESS * dbproc, const char *name)
 	add_bread_crumb();
 
 	fprintf(stdout, "Creating %s.%s..%s\n", SERVER, DATABASE, name);
+	sql_cmd(dbproc, INPUT);
+	sql_cmd(dbproc, INPUT);
 
-	dbcmd(dbproc, create_table_sql);
-#if 1
-	dbfcmd(dbproc, 	"select colid, cast(c.name as varchar(30)) as name, c.length "
-			", '  '+ substring('NY', convert(bit,(c.status & 8))+1,1) as Nulls " 
-			"from syscolumns as c left join systypes as t on c.usertype = t.usertype "
-			"where c.id = object_id('%s') order by colid", name );
-#endif
 	if (dbsqlexec(dbproc) == FAIL) {
 		add_bread_crumb();
 		res = 1;
@@ -276,23 +269,9 @@ main(int argc, char **argv)
 	printf("done\n");
 
 	add_bread_crumb();
-#if 0
-	fprintf(stdout, "select * from %s\n", table_name);
-	dbfcmd(dbproc, "select * from %s\n", table_name);
-#endif
+
 #if 1
-	dbfcmd(dbproc, 	"select   'nullable_char' as col, count(*) nrows"
-				", datalength(nullable_char) as len, nullable_char as value "
-			"from %s group by nullable_char\n", table_name);
-	dbfcmd(dbproc, 	"UNION\n"
-			"select   'nullable_varchar' as col, count(*) nrows"
-				", datalength(nullable_varchar) as len, nullable_varchar as value "
-			"from %s group by nullable_varchar\n", table_name);
-	dbfcmd(dbproc, 	"UNION\n"
-			"select   'nullable_int' as col, count(*) nrows"
-				", datalength(nullable_int) as len, cast(nullable_int as varchar(6))as value "
-			"from %s group by nullable_int\n", table_name);
-	dbfcmd(dbproc, "order by col, len, nrows\n");
+	sql_cmd(dbproc, INPUT);
 
 	dbsqlexec(dbproc);
 	while ((i=dbresults(dbproc)) == SUCCEED) {
@@ -308,8 +287,7 @@ main(int argc, char **argv)
 	} else {
 		fprintf(stdout, "Dropping table %s\n", table_name);
 		add_bread_crumb();
-		sprintf(cmd, "drop table %s", table_name);
-		dbcmd(dbproc, cmd);
+		sql_cmd(dbproc, INPUT);
 		add_bread_crumb();
 		dbsqlexec(dbproc);
 		add_bread_crumb();
@@ -323,7 +301,7 @@ main(int argc, char **argv)
 
 	failed = 0;
 
-	fprintf(stdout, "dblib %s on %s\n", (failed ? "failed!" : "okay"), __FILE__);
+	fprintf(stdout, "%s %s\n", __FILE__, (failed ? "failed!" : "OK"));
 	free_bread_crumb();
 	return failed ? 1 : 0;
 }
diff --git a/src/dblib/unittests/bcp.sql b/src/dblib/unittests/bcp.sql
new file mode 100644
index 0000000..3bb08b0
--- /dev/null
+++ b/src/dblib/unittests/bcp.sql
@@ -0,0 +1,154 @@
+if exists (select 1 from sysobjects where type = 'U' and name = 'all_types_bcp_unittest') drop table all_types_bcp_unittest
+go
+CREATE TABLE all_types_bcp_unittest (
+	  not_null_bit			bit NOT NULL
+
+	, not_null_char			char(10) NOT NULL
+	, not_null_varchar		varchar(10) NOT NULL
+
+	, not_null_datetime		datetime NOT NULL
+	, not_null_smalldatetime	smalldatetime NOT NULL
+
+	, not_null_money		money NOT NULL
+	, not_null_smallmoney		smallmoney NOT NULL
+
+	, not_null_float		float NOT NULL
+	, not_null_real			real NOT NULL
+
+	, not_null_decimal		decimal(5,2) NOT NULL
+	, not_null_numeric		numeric(5,2) NOT NULL
+
+	, not_null_int			int NOT NULL
+	, not_null_smallint		smallint NOT NULL
+	, not_null_tinyint		tinyint NOT NULL
+
+	, nullable_char			char(10)  NULL
+	, nullable_varchar		varchar(10)  NULL
+
+	, nullable_datetime		datetime  NULL
+	, nullable_smalldatetime	smalldatetime  NULL
+
+	, nullable_money		money  NULL
+	, nullable_smallmoney		smallmoney  NULL
+
+	, nullable_float		float  NULL
+	, nullable_real			real  NULL
+
+	, nullable_decimal		decimal(5,2)  NULL
+	, nullable_numeric		numeric(5,2)  NULL
+
+	, nullable_int			int  NULL
+	, nullable_smallint		smallint  NULL
+	, nullable_tinyint		tinyint  NULL
+
+	/* Excludes: 
+	 * binary
+	 * image
+	 * uniqueidentifier
+	 * varbinary
+	 * text
+	 * timestamp
+	 * nchar
+	 * ntext
+	 * nvarchar
+	 */
+)
+
+INSERT all_types_bcp_unittest   
+VALUES ( 1 -- not_null_bit
+
+	, 'a char' -- not_null_char
+	, 'a varchar' -- not_null_varchar
+
+	, 'Dec 17 2003  3:44PM' -- not_null_datetime
+	, 'Dec 17 2003  3:44PM' -- not_null_smalldatetime
+
+	, 12.34 -- not_null_money
+	, 12.34 -- not_null_smallmoney
+
+	, 12.34 -- not_null_float
+	, 12.34 -- not_null_real
+
+	, 12.34 -- not_null_decimal
+	, 12.34 -- not_null_numeric
+
+	, 1234 -- not_null_int
+	, 1234 -- not_null_smallint
+	, 123  -- not_null_tinyint
+
+	, 'a char' -- nullable_char
+	, 'a varchar' -- nullable_varchar
+
+	, 'Dec 17 2003  3:44PM' -- nullable_datetime
+	, 'Dec 17 2003  3:44PM' -- nullable_smalldatetime
+
+	, 12.34 -- nullable_money
+	, 12.34 -- nullable_smallmoney
+
+	, 12.34 -- nullable_float
+	, 12.34 -- nullable_real
+
+	, 12.34 -- nullable_decimal
+	, 12.34 -- nullable_numeric
+
+	, 1234 -- nullable_int
+	, 1234 -- nullable_smallint
+	, 123  -- nullable_tinyint
+)
+INSERT all_types_bcp_unittest
+				( not_null_bit			
+
+				, not_null_char			
+				, not_null_varchar		
+
+				, not_null_datetime		
+				, not_null_smalldatetime	
+
+				, not_null_money		
+				, not_null_smallmoney		
+
+				, not_null_float		
+				, not_null_real			
+
+				, not_null_decimal		
+				, not_null_numeric		
+
+				, not_null_int			
+				, not_null_smallint		
+				, not_null_tinyint		
+				) 
+VALUES (
+	  1 -- not_null_bit
+
+	, 'a char' -- not_null_char
+	, 'a varchar' -- not_null_varchar
+
+	, 'Dec 17 2003  3:44PM' -- not_null_datetime
+	, 'Dec 17 2003  3:44PM' -- not_null_smalldatetime
+
+	, 12.34 -- not_null_money
+	, 12.34 -- not_null_smallmoney
+
+	, 12.34 -- not_null_float
+	, 12.34 -- not_null_real
+
+	, 12.34 -- not_null_decimal
+	, 12.34 -- not_null_numeric
+
+	, 1234 -- not_null_int
+	, 1234 -- not_null_smallint
+	, 123  -- not_null_tinyint
+)
+go
+select colid, cast(c.name as varchar(30)) as name, c.length , '  '+ substring('NY', convert(bit,(c.status & 8))+1,1) as Nulls from syscolumns as c left join systypes as t on c.usertype = t.usertype where c.id = object_id('all_types_bcp_unittest') order by colid
+go
+select   'nullable_char' as col, count(*) nrows, datalength(nullable_char) as len, nullable_char as value from all_types_bcp_unittest group by nullable_char
+UNION
+select   'nullable_varchar' as col, count(*) nrows, datalength(nullable_varchar) as len, nullable_varchar as value from all_types_bcp_unittest group by nullable_varchar
+UNION
+select   'nullable_int' as col, count(*) nrows, datalength(nullable_int) as len, cast(nullable_int as varchar(6))as value from all_types_bcp_unittest group by nullable_int
+order by col, len, nrows
+
+go
+drop table all_types_bcp_unittest
+go
diff --git a/src/dblib/unittests/common.c b/src/dblib/unittests/common.c
index 1a7d5de..a087112 100644
--- a/src/dblib/unittests/common.c
+++ b/src/dblib/unittests/common.c
@@ -16,7 +16,9 @@
 #include "replacements.h"
 #endif
 
-static char software_version[] = "$Id: common.c,v 1.25 2008/11/25 22:58:29 jklowden Exp $";
+#include <err.h>
+
+static char software_version[] = "$Id: common.c,v 1.26 2009/02/01 22:29:39 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 typedef struct _tag_memcheck_t
@@ -32,10 +34,18 @@ static memcheck_t *breadcrumbs = NULL;
 static int num_breadcrumbs = 0;
 static const unsigned int BREADCRUMB = 0xABCD7890;
 
+#if !defined(PATH_MAX)
+#define PATH_MAX 256
+#endif
+
 char USER[512];
 char SERVER[512];
 char PASSWORD[512];
 char DATABASE[512];
+
+static char sql_file[PATH_MAX];
+FILE* INPUT;
+
 static char *DIRNAME = NULL;
 static const char *BASENAME = NULL;
 
@@ -80,23 +90,17 @@ tds_dirname(char* path)
 
 #endif
 
-#ifndef MAXPATHLEN
-#define MAXPATHLEN 512
-#endif
-
 int
 read_login_info(int argc, char **argv)
 {
-	extern char *optarg;
-	extern int optind;
-	
+	size_t len;
 	FILE *in = NULL;
 #if !defined(__MINGW32__) && !defined(_MSC_VER)
 	int ch;
 #endif
 	char line[512];
 	char *s1, *s2;
-	char filename[MAXPATHLEN];
+	char filename[PATH_MAX];
 	static const char *PWD = "../../../PWD";
 	struct { char *username, *password, *servername, *database; char fverbose; } options;
 	
@@ -200,9 +204,47 @@ read_login_info(int argc, char **argv)
 	}
 	
 	printf("found %s.%s for %s in \"%s\"\n", SERVER, DATABASE, USER, filename);
+	
+#if 0
+	dbrecftos(BASENAME);
+#endif
+	len = snprintf(sql_file, sizeof(sql_file), "%s.sql", BASENAME);
+	assert(len <= sizeof(sql_file));
+
+	if ((INPUT = fopen(sql_file, "r")) == NULL) {
+		fflush(stdout);
+		warnx("could not open SQL input file \"%s\"\n", sql_file);
+	}
+	
+	printf("SQL text will be read from %s\n", sql_file);
+
 	return 0;
 }
 
+/*
+ * Fill the command buffer from a file while echoing it to standard output.
+ */
+RETCODE 
+sql_cmd(DBPROCESS *dbproc, FILE *stream)
+{
+	char line[2048], *p = line;
+	int i = 0;
+	RETCODE erc=SUCCEED;
+	
+	while ((p = fgets(line, (int)sizeof(line), stream)) != NULL && strcasecmp("go\n", p) != 0) {
+		printf("\t%3d: %s", ++i, p);
+		if ((erc = dbcmd(dbproc, p)) != SUCCEED) {
+			errx(1, "%s: error: could write \"%s\" to dbcmd()\n", BASENAME, p);
+		}
+	}
+
+	if (ferror(stream)) {
+		errx(1, "%s: error: could not read SQL input file \"%s\"\n", BASENAME, sql_file);
+	}
+
+	return erc;
+}
+
 void
 check_crumbs(void)
 {
@@ -306,6 +348,7 @@ syb_msg_handler(DBPROCESS * dbproc, DBINT msgno, int msgstate, int severity, cha
 	 * If the severity is something other than 0 or the msg number is
 	 * 0 (user informational messages).
 	 */
+	fflush(stdout);
 	if (severity >= 0 || msgno == 0) {
 		/*
 		 * If the message was something other than informational, and
@@ -364,6 +407,7 @@ syb_err_handler(DBPROCESS * dbproc, int severity, int dberr, int oserr, char *db
 		}
 	}
 
+	fflush(stdout);
 	fprintf(stderr,
 		"DB-LIBRARY error (dberr %d (severity %d): \"%s\"; oserr %d: \"%s\")\n",
 		dberr, severity, dberrstr ? dberrstr : "(null)", oserr, oserrstr ? oserrstr : "(null)");
diff --git a/src/dblib/unittests/common.h b/src/dblib/unittests/common.h
index 67b72db..0f5d023 100644
--- a/src/dblib/unittests/common.h
+++ b/src/dblib/unittests/common.h
@@ -2,7 +2,7 @@
 #ifndef COMMON_h
 #define COMMON_h
 
-static char rcsid_common_h[] = "$Id: common.h,v 1.15 2008/11/25 22:58:29 jklowden Exp $";
+static char rcsid_common_h[] = "$Id: common.h,v 1.16 2009/02/01 22:29:39 jklowden Exp $";
 static void *no_unused_common_h_warn[] = { rcsid_common_h, no_unused_common_h_warn };
 
 #if HAVE_CONFIG_H
@@ -76,6 +76,7 @@ extern char PASSWORD[512];
 extern char USER[512];
 extern char SERVER[512];
 extern char DATABASE[512];
+extern FILE* INPUT;
 
 void set_malloc_options(void);
 int read_login_info(int argc, char **argv);
@@ -86,6 +87,8 @@ int syb_msg_handler(DBPROCESS * dbproc,
 		    DBINT msgno, int msgstate, int severity, char *msgtext, char *srvname, char *procname, int line);
 int syb_err_handler(DBPROCESS * dbproc, int severity, int dberr, int oserr, char *dberrstr, char *oserrstr);
 
+RETCODE sql_cmd(DBPROCESS *dbproc, FILE *stream);
+
 #define int2ptr(i) ((void*)(((char*)0)+(i)))
 #define ptr2int(p) ((int)(((char*)(p))-((char*)0)))
 
diff --git a/src/dblib/unittests/dbmorecmds.c b/src/dblib/unittests/dbmorecmds.c
index c5b76f2..a01522b 100644
--- a/src/dblib/unittests/dbmorecmds.c
+++ b/src/dblib/unittests/dbmorecmds.c
@@ -5,12 +5,11 @@
 
 #include "common.h"
 
-static char software_version[] = "$Id: dbmorecmds.c,v 1.13 2008/11/25 22:58:29 jklowden Exp $";
+static char software_version[] = "$Id: dbmorecmds.c,v 1.14 2009/02/01 22:29:39 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version,	no_unused_var_warn };
 
 int failed = 0;
-const static char query[] = "select count(*) from sysusers\n"
-			    "select name from sysobjects compute count(name)\n";
+
 int
 main(int argc, char **argv)
 {
@@ -65,7 +64,7 @@ main(int argc, char **argv)
 	add_bread_crumb();
 
 	fprintf(stdout, "creating table\n");
-	dbcmd(dbproc, "create table #dblib0024 (i int not null, s char(10) not null)");
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	while (dbresults(dbproc) != NO_MORE_RESULTS) {
 		/* nop */
@@ -73,19 +72,15 @@ main(int argc, char **argv)
 
 	fprintf(stdout, "insert\n");
 	for (i = 0; i < rows_to_add; i++) {
-		char cmd[1024];
-
-		sprintf(cmd, "insert into #dblib0024 values (%d, 'row %03d')", i, i);
-		fprintf(stdout, "%s\n", cmd);
-		dbcmd(dbproc, cmd);
+		sql_cmd(dbproc, INPUT);
 		dbsqlexec(dbproc);
 		while (dbresults(dbproc) != NO_MORE_RESULTS) {
 			/* nop */
 		}
 	}
 
-	fprintf(stdout, "select 1\n");
-	dbcmd(dbproc, "select count(*) from #dblib0024 -- order by i");
+	fprintf(stdout, "select one resultset\n");
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	add_bread_crumb();
 
@@ -108,8 +103,8 @@ main(int argc, char **argv)
 
 	dbcancel(dbproc);
 
-	fprintf(stdout, query);
-	dbcmd(dbproc, query);
+	fprintf(stdout, "select two resultsets\n");
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 
 	nresults = 0;
@@ -136,7 +131,7 @@ main(int argc, char **argv)
 	dbexit();
 	add_bread_crumb();
 
-	fprintf(stdout, "dblib %s on %s\n", (failed ? "failed!" : "okay"), __FILE__);
+	fprintf(stdout, "%s %s\n", __FILE__, (failed ? "failed!" : "OK"));
 	free_bread_crumb();
 	return failed ? 1 : 0;
 }
diff --git a/src/dblib/unittests/dbmorecmds.sql b/src/dblib/unittests/dbmorecmds.sql
new file mode 100644
index 0000000..be381b3
--- /dev/null
+++ b/src/dblib/unittests/dbmorecmds.sql
@@ -0,0 +1,27 @@
+create table #dblib0024 (i int not null, s char(10) not null)
+go
+insert into #dblib0024 values (0, 'row 000')
+go
+insert into #dblib0024 values (1, 'row 001')
+go
+insert into #dblib0024 values (2, 'row 002')
+go
+insert into #dblib0024 values (3, 'row 003')
+go
+insert into #dblib0024 values (4, 'row 004')
+go
+insert into #dblib0024 values (5, 'row 005')
+go
+insert into #dblib0024 values (6, 'row 006')
+go
+insert into #dblib0024 values (7, 'row 007')
+go
+insert into #dblib0024 values (8, 'row 008')
+go
+insert into #dblib0024 values (9, 'row 009')
+go
+select count(*) from #dblib0024 -- order by i
+go
+select count(*) from sysusers
+select name from sysobjects compute count(name)
+go
diff --git a/src/dblib/unittests/done_handling.c b/src/dblib/unittests/done_handling.c
index 53dc3fc..c2e5cc0 100644
--- a/src/dblib/unittests/done_handling.c
+++ b/src/dblib/unittests/done_handling.c
@@ -1,6 +1,6 @@
 #include "common.h"
 
-static char software_version[] = "$Id: done_handling.c,v 1.7 2007/12/28 23:00:42 jklowden Exp $";
+static char software_version[] = "$Id: done_handling.c,v 1.8 2009/02/01 22:29:39 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 /*
@@ -28,21 +28,58 @@ static DBPROCESS *dbproc;
 static int silent = 0;
 static int check_idle = 0;
 
-static void
-query(const char *query)
+/* print functions adapted from src/dblib/dblib.c */
+static const char *
+prdbretcode(int retcode)
+{
+	static char unknown[24];
+	switch(retcode) {
+	case REG_ROW:		return "REG_ROW/MORE_ROWS";
+	case NO_MORE_ROWS:	return "NO_MORE_ROWS";
+	case BUF_FULL:		return "BUF_FULL";
+	case NO_MORE_RESULTS:	return "NO_MORE_RESULTS";
+	case SUCCEED:		return "SUCCEED";
+	case FAIL:		return "FAIL";
+	default:
+		sprintf(unknown, "oops: %u ??", retcode);
+	}
+	return unknown;
+}
+
+static const char *
+prretcode(int retcode)
+{
+	static char unknown[24];
+	switch(retcode) {
+	case SUCCEED:		return "SUCCEED";
+	case FAIL:		return "FAIL";
+	case NO_MORE_RESULTS:	return "NO_MORE_RESULTS";
+	default:
+		sprintf(unknown, "oops: %u ??", retcode);
+	}
+	return unknown;
+}
+
+static RETCODE
+query(const char comment[])
 {
-	printf("query: %s\n", query);
-	dbcmd(dbproc, (char *) query);
+	RETCODE erc;
+	
+	if (comment)
+		printf("%s\n", comment);
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
-	while (dbresults(dbproc) == SUCCEED) {
+	while ((erc = dbresults(dbproc)) == SUCCEED) {
 		/* nop */
 	}
 }
 
+typedef const char* (*prfunc)(int);
+
 static void
-check_state(void)
+check_state(const char name[], prfunc print, int erc)
 {
-	printf("State ");
+	printf("State %-15s %-20s ", name, print(erc));
 	if (dbnumcols(dbproc) > 0)
 		printf("COLS(%d) ", dbnumcols(dbproc));
 	/* row count */
@@ -73,64 +110,48 @@ check_state(void)
 }
 
 static void
-do_test(const char *query)
+do_test(const char comment[])
 {
 	int ret;
+	prfunc print_with = NULL;
 
-	printf("test query %s\n", query);
-	dbcmd(dbproc, (char *) query);
-
-	printf("sqlexec ");
-	dbsqlexec(dbproc);
-
-	check_state();
-
-	printf("nextrow ");
-	dbnextrow(dbproc);
+	if (comment)
+		printf("%s\n", comment);
+	sql_cmd(dbproc, INPUT);
 
-	check_state();
+	check_state("sqlexec ", prretcode, dbsqlexec(dbproc));
 
-	printf("nextrow ");
-	dbnextrow(dbproc);
-
-	check_state();
-
-	printf("results ");
-	dbresults(dbproc);
-
-	check_state();
-
-	printf("nextrow ");
-	dbnextrow(dbproc);
-
-	check_state();
-
-	printf("nextrow ");
-	dbnextrow(dbproc);
-
-	check_state();
+	check_state("nextrow ", prdbretcode, dbnextrow(dbproc));
+	check_state("nextrow ", prdbretcode, dbnextrow(dbproc));
+	check_state("results ", prretcode,   dbresults(dbproc));
+	check_state("nextrow ", prdbretcode, dbnextrow(dbproc));
+	check_state("nextrow ", prdbretcode, dbnextrow(dbproc));
 
 	check_idle = 0;
 	for (;;) {
-		printf("results \n");
 		ret = dbresults(dbproc);
-		check_state();
-		if (ret != SUCCEED)
+		check_state("results ", prretcode, ret);
+		if (ret != SUCCEED) {
+			print_with = prretcode;
 			break;
+		}
 
 		do {
-			printf("nextrow ");
 			ret = dbnextrow(dbproc);
-			check_state();
-		} while (ret == SUCCEED);
+			check_state("nextrow ", prdbretcode, ret);
+		} while (ret == REG_ROW);
+		print_with = prdbretcode;
 	}
-	check_state();
+	check_state("more results?", print_with, ret);
 }
 
 int
 main(int argc, char *argv[])
 {
+	const static int invalid_column_name = 207;
+	RETCODE erc;
 	LOGINREC *login;	/* Our login information. */
+	int i;
 
 	setbuf(stdout, NULL);
 	read_login_info(argc, argv);
@@ -141,6 +162,16 @@ main(int argc, char *argv[])
 	dberrhandle(err_handler);
 	dbmsghandle(msg_handler);
 
+#if 0
+	/* 
+	 * FIXME: Should be able to use the common err/msg handlers, but something about
+	 * the IDLE checking causes them to fail.  Not sure about purpose of IDLE checking.
+	 * -- jkl January 2009
+	 */
+	dberrhandle(syb_err_handler);
+	dbmsghandle(syb_msg_handler);
+#endif
+
 	login = dblogin();
 	DBSETLUSER(login, USER);
 	DBSETLPWD(login, PASSWORD);
@@ -153,35 +184,33 @@ main(int argc, char *argv[])
 	if (strlen(DATABASE))
 		dbuse(dbproc, DATABASE);
 
-	query("create table #dummy (s char(10))");
-	query("insert into #dummy values('xxx')");
-	query("if object_id('done_test') is not NULL drop proc done_test");
-	query("create proc done_test @a varchar(10) output as select * from #dummy");
-	query("if object_id('done_test2') is not NULL drop proc done_test2");
-	query("create proc done_test2 as select * from #dummy where s = 'aaa' select * from #dummy");
-
+	for (i=0; i < 6; i++) {
+		erc = query(NULL);
+	}
+#if 0	
+	check_state("setup done ", prretcode, erc);
+	
+	printf("wasting results\n");
+	while ((erc = dbresults(dbproc)) == SUCCEED) {
+		while (dbnextrow(dbproc) == REG_ROW); /* no-op */
+	}	
+#endif
 	check_idle = 1;
 
-	/* normal row */
-	do_test("select * from #dummy");
-	/* normal row with no count */
-	query("set nocount on");
-	do_test("select * from #dummy");
-	query("set nocount off");
-	/* normal row without rows */
-	do_test("select * from #dummy where 0=1");
-	/* error query */
-	do_test("select dklghdlgkh from #dummy");
-	/* store procedure call with output parameters */
-	do_test("declare @s varchar(10) exec done_test @s output");
-
-	do_test("declare @i int");
-
-	do_test("exec done_test2");
-	do_test("declare @i int");
-
-	query("drop proc done_test");
-	query("drop proc done_test2");
+	do_test("normal row with rowcount on");
+	query("turn rowcount off");
+	do_test("normal row with rowcount off");
+	query("turn rowcount back on");
+	do_test("normal row without rows");
+	dbsetuserdata(dbproc, &invalid_column_name);
+	do_test("error query");
+	do_test("stored procedure call with output parameters");
+
+	do_test("execute done2");
+
+	query("drop done_test");
+
+	query("drop done_test2");
 
 	dbexit();
 	return 0;
diff --git a/src/dblib/unittests/done_handling.sql b/src/dblib/unittests/done_handling.sql
new file mode 100644
index 0000000..525a513
--- /dev/null
+++ b/src/dblib/unittests/done_handling.sql
@@ -0,0 +1,38 @@
+create table #dummy (s char(10))
+go
+insert into #dummy values('xxx')
+go
+if object_id('done_test') is not NULL drop proc done_test
+go
+create proc done_test @a varchar(10) output 
+as 
+	select * from #dummy
+go
+if object_id('done_test2') is not NULL drop proc done_test2
+go
+create proc done_test2 
+as 
+	select * from #dummy where s = 'aaa' 
+	select * from #dummy
+go
+select * from #dummy	/* normal row */
+go
+set nocount on
+go
+select * from #dummy	/* normal row with no count */
+go
+set nocount off
+go
+select * from #dummy where 0=1	/* normal row without rows */
+go
+select dklghdlgkh from #dummy	/* error query */
+go
+/* stored procedure call with output parameters */
+declare @s varchar(10) exec done_test @s output	
+go
+exec done_test2
+go
+drop proc done_test
+go
+drop proc done_test2
+go
diff --git a/src/dblib/unittests/rpc.c b/src/dblib/unittests/rpc.c
index bd14096..5c54197 100644
--- a/src/dblib/unittests/rpc.c
+++ b/src/dblib/unittests/rpc.c
@@ -5,7 +5,7 @@
 
 #include "common.h"
 
-static char software_version[] = "$Id: rpc.c,v 1.35 2008/11/25 22:58:29 jklowden Exp $";
+static char software_version[] = "$Id: rpc.c,v 1.36 2009/02/01 22:29:39 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static char cmd[4096];
@@ -48,8 +48,7 @@ init_proc(DBPROCESS * dbproc, const char *name)
 	if (name[0] != '#') {
 		fprintf(stdout, "Dropping procedure %s\n", name);
 		add_bread_crumb();
-		sprintf(cmd, "DROP PROCEDURE %s", name);
-		dbcmd(dbproc, cmd);
+		sql_cmd(dbproc, INPUT);
 		add_bread_crumb();
 		dbsqlexec(dbproc);
 		add_bread_crumb();
@@ -60,8 +59,7 @@ init_proc(DBPROCESS * dbproc, const char *name)
 	}
 
 	fprintf(stdout, "Creating procedure %s\n", name);
-	sprintf(cmd, procedure_sql, name);
-	dbcmd(dbproc, cmd);
+	sql_cmd(dbproc, INPUT);
 	if ((ret = dbsqlexec(dbproc)) == FAIL) {
 		add_bread_crumb();
 		if (name[0] == '#')
@@ -414,8 +412,7 @@ main(int argc, char **argv)
 
 	fprintf(stdout, "Dropping procedure\n");
 	add_bread_crumb();
-	sprintf(cmd, "DROP PROCEDURE %s", proc_name);
-	dbcmd(dbproc, cmd);
+	sql_cmd(dbproc, INPUT);
 	add_bread_crumb();
 	dbsqlexec(dbproc);
 	add_bread_crumb();
@@ -426,7 +423,7 @@ main(int argc, char **argv)
 	dbexit();
 	add_bread_crumb();
 
-	fprintf(stdout, "dblib %s on %s\n", (failed ? "failed!" : "okay"), __FILE__);
+	fprintf(stdout, "%s %s\n", __FILE__, (failed ? "failed!" : "OK"));
 	free_bread_crumb();
 
 	free(save_param.name);
diff --git a/src/dblib/unittests/rpc.sql b/src/dblib/unittests/rpc.sql
new file mode 100644
index 0000000..7b35e76
--- /dev/null
+++ b/src/dblib/unittests/rpc.sql
@@ -0,0 +1,44 @@
+CREATE PROCEDURE #t0022 
+  @null_input varchar(30) OUTPUT 
+, @first_type varchar(30) OUTPUT 
+, @nullout int OUTPUT
+, @nrows int OUTPUT 
+, @c varchar(20)
+, @nv nvarchar(20) = N'hello'
+AS 
+BEGIN 
+select @null_input = max(convert(varchar(30), name)) from systypes 
+select @first_type = min(convert(varchar(30), name)) from systypes 
+select name from sysobjects where 0=1
+select distinct convert(varchar(30), name) as 'type'  from systypes 
+where name in ('int', 'char', 'text') 
+select @nrows = @@rowcount 
+select distinct @nv as '@nv', convert(varchar(30), name) as name  from sysobjects where type = 'S' 
+return 42 
+END 
+
+go
+DROP PROCEDURE t0022
+go
+CREATE PROCEDURE t0022 
+  @null_input varchar(30) OUTPUT 
+, @first_type varchar(30) OUTPUT 
+, @nullout int OUTPUT
+, @nrows int OUTPUT 
+, @c varchar(20)
+, @nv nvarchar(20) = N'hello'
+AS 
+BEGIN 
+select @null_input = max(convert(varchar(30), name)) from systypes 
+select @first_type = min(convert(varchar(30), name)) from systypes 
+select name from sysobjects where 0=1
+select distinct convert(varchar(30), name) as 'type'  from systypes 
+where name in ('int', 'char', 'text') 
+select @nrows = @@rowcount 
+select distinct @nv as '@nv', convert(varchar(30), name) as name  from sysobjects where type = 'S' 
+return 42 
+END 
+
+go
+DROP PROCEDURE t0022
+go
diff --git a/src/dblib/unittests/t0001.c b/src/dblib/unittests/t0001.c
index 9d592b5..56ae4d8 100644
--- a/src/dblib/unittests/t0001.c
+++ b/src/dblib/unittests/t0001.c
@@ -5,7 +5,7 @@
 
 #include "common.h"
 
-static char software_version[] = "$Id: t0001.c,v 1.27 2008/11/25 22:58:29 jklowden Exp $";
+static char software_version[] = "$Id: t0001.c,v 1.28 2009/02/01 22:29:39 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 
@@ -82,36 +82,20 @@ main(int argc, char **argv)
 #ifdef DBQUOTEDIDENT
 	fprintf(stdout, "QUOTED_IDENTIFIER is %s\n", (dbisopt(dbproc, DBQUOTEDIDENT, NULL))? "ON":"OFF");
 #endif
-	
-	fprintf(stdout, "creating table\n");
-	dbcmd(dbproc, "create table #dblib0001 (i int not null, s char(10) not null)");
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	while (dbresults(dbproc) == SUCCEED) {
 		/* nop */
 	}
 
-	fprintf(stdout, "insert\n");
-	for (i = 0; i < rows_to_add; i++) {
-		char cmd[1024];
-
-#ifdef DBQUOTEDIDENT
-		if(dbisopt(dbproc, DBQUOTEDIDENT, NULL)) 
-			sprintf(cmd, "insert into #dblib0001 values (%d, 'row %03d')", i, i);
-		else
-			sprintf(cmd, "insert into #dblib0001 values (%d, \"row %03d\")", i, i);
-#else
-		sprintf(cmd, "insert into #dblib0001 values (%d, 'row %03d')", i, i);
-#endif
-		fprintf(stdout, "%s\n", cmd);
-		dbcmd(dbproc, cmd);
+	for (i = 0; i < rows_to_add && sql_cmd(dbproc, INPUT) == SUCCEED; i++) {
 		dbsqlexec(dbproc);
 		while (dbresults(dbproc) == SUCCEED) {
 			/* nop */
 		}
 	}
 
-	fprintf(stdout, "select\n");
-	dbcmd(dbproc, "select * from #dblib0001 order by i");
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	add_bread_crumb();
 
@@ -119,7 +103,7 @@ main(int argc, char **argv)
 	if (dbresults(dbproc) != SUCCEED) {
 		add_bread_crumb();
 		failed = 1;
-		fprintf(stdout, "Was expecting a result set.\n");
+		fprintf(stderr, "error: expected a result set, none returned.\n");
 		exit(1);
 	}
 	add_bread_crumb();
@@ -186,7 +170,7 @@ main(int argc, char **argv)
 	dbexit();
 	add_bread_crumb();
 
-	fprintf(stdout, "dblib %s on %s\n", (failed ? "failed!" : "okay"), __FILE__);
+	fprintf(stdout, "%s %s\n", __FILE__, (failed ? "failed!" : "OK"));
 	free_bread_crumb();
 	return failed ? 1 : 0;
 }
